Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jdesktop.swingx.event
Class WeakEventListenerList

    java.lang.Object
      org.jdesktop.swingx.event.WeakEventListenerList

All Implemented Interfaces:
  java.io.Serializable

    public class WeakEventListenerList

extends java.lang.Object
implements java.io.Serializable

A class that holds a list of EventListeners. A single instance can be used to hold all listeners (of all types) for the instance using the list. It is the responsibility of the class using the EventListenerList to provide type-safe API (preferably conforming to the JavaBeans spec) and methods which dispatch event notification methods to appropriate Event Listeners on the list. The main benefit that this class provides is that it releases garbage collected listeners (internally uses weak references).

PENDING: serialization support Usage example: Say one is defining a class that sends out FooEvents, and one wants to allow users of the class to register FooListeners and receive notification when FooEvents occur. The following should be added to the class definition:

     EventListenerList listenerList = new EventListenerList();
     FooEvent fooEvent = null;

     public void addFooListener(FooListener l) {
         listenerList.add(FooListener.class, l);
     }

     public void removeFooListener(FooListener l) {
         listenerList.remove(FooListener.class, l);
     }

     // Notify all listeners that have registered interest for
     // notification on this event type.  The event instance
     // is lazily created using the parameters passed into
     // the fire method.

     protected void fireFooXXX() {
         // Guaranteed to return a non-null array
         FooListener[] listeners = listenerList.getListeners(FooListener.class);
         // Process the listeners last to first, notifying
         // those that are interested in this event
         for (FooListener listener: listeners) {
                 // Lazily create the event:
                 if (fooEvent == null)
                     fooEvent = new FooEvent(this);
                 listener.fooXXX(fooEvent);
             }
         }
     }

foo should be changed to the appropriate name, and fireFooXxx to the appropriate method name. One fire method should exist for each notification method in the FooListener interface.

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. As of 1.4, support for long term storage of all JavaBeansTM has been added to the `java.beans` package. Please see `XMLEncoder`.

Version:
  1.37 11/17/05
Author:
  Georges Saab, Hans Muller, James Gosling
See Also:
  Serialized Form

Field Summary
`protected java.util.List<java.lang.Class<? extends java.util.EventListener>>` | `classes`
`protected java.util.List<java.lang.ref.WeakReference<? extends java.util.EventListener>>` | `weakReferences`

Constructor Summary
`WeakEventListenerList()`

Method Summary
`
`<T extends java.util.EventListener> void`
` | `add(java.lang.Class<T> t, T l)` Adds the listener as a listener of the specified type.
`java.lang.Object[]` | `getListenerList()` Passes back the event listener list as an array of ListenerType-listener pairs.
`
`<T extends java.util.EventListener> T[]`
` | `getListeners(java.lang.Class<T> t)` Return an array of all the listeners of the given type.
`
`<T extends java.util.EventListener> void`
` | `remove(java.lang.Class<T> t, T l)` Removes the listener as a listener of the specified type.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### weakReferences

    protected transient java.util.List<java.lang.ref.WeakReference<? extends java.util.EventListener>> weakReferences

### classes

    protected transient java.util.List<java.lang.Class<? extends java.util.EventListener>> classes

Constructor Detail

### WeakEventListenerList

    public WeakEventListenerList()

Method Detail

### getListenerList

    public java.lang.Object[] getListenerList()

  Passes back the event listener list as an array of ListenerType-listener pairs. As a side-effect, cleans out any garbage collected listeners before building the array.

  Returns:
    a array of listenerType-listener pairs.

### getListeners

    public <T extends java.util.EventListener> T[] getListeners(java.lang.Class<T> t)

  Return an array of all the listeners of the given type. As a side-effect, cleans out any garbage collected listeners before building the array.

  Returns:
    all of the listeners of the specified type.
  Throws:
    `java.lang.ClassCastException` - if the supplied class is not assignable to EventListener
  Since:
    1.3

### add

    public <T extends java.util.EventListener> void add(java.lang.Class<T> t,
                                                        T l)

  Adds the listener as a listener of the specified type. As a side-effect, cleans out any garbage collected listeners before adding.

  Parameters:
    `t` - the type of the listener to be added
    `l` - the listener to be added

### remove

    public <T extends java.util.EventListener> void remove(java.lang.Class<T> t,
                                                           T l)

  Removes the listener as a listener of the specified type.

  Parameters:
    `t` - the type of the listener to be removed
    `l` - the listener to be removed

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010. All Rights Reserved.